config/routes.rb
Rails.application.routes.draw do
  resources :pokemon_trainers
  resources :pokemons
  
  root "pokemons#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/captured_pokemon.rb
class CapturedPokemon < ApplicationRecord
    belongs_to :pokemon_trainer, optional: true
end

app/models/pokemon_trainer.rb
class PokemonTrainer < ApplicationRecord
    has_many :captured_pokemon    
    validates_presence_of :name, :last_name
    validates_format_of :email, with: URI::MailTo::EMAIL_REGEXP
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  before_action :set_locale

  def set_locale
    logger.debug "* Accept-Language: #{request.env['HTTP_ACCEPT_LANGUAGE']}"
    I18n.locale = params[:locale] || extract_locale_from_accept_language_header
    logger.debug "* Locale set to '#{I18n.locale}'"
  end
  
  private
    def extract_locale_from_accept_language_header
      request.env['HTTP_ACCEPT_LANGUAGE'].scan(/^[a-z]{2}/).first
    end
end

app/controllers/pokemon_trainers_controller.rb
class PokemonTrainersController < ApplicationController
    def index
        @trainers = PokemonTrainer.all
    end

    def show
        @trainers = PokemonTrainer.find(params[:id]) 
    end

    def new
        @trainers = PokemonTrainer.new 
    end

    def create
        @trainers = PokemonTrainer.create(trainer_params)
        if @trainers.save
            pokemon_to_trainer(params[:pokemon_trainer][:captured_pokemon], params[:id])
            redirect_to pokemon_trainers_path
        else
            render :new
        end 
    end

    def edit
        @trainers = PokemonTrainer.find(params[:id])
    end

    def update
        @trainers = PokemonTrainer.find(params[:id])
            if @trainers.update(trainer_params)
                pokemon_to_trainer(params[:pokemon_trainer][:captured_pokemon], params[:id])
                redirect_to pokemon_trainers_path
            else
                render :edit
            end
    end

    def destroy
        @trainers = PokemonTrainer.find(params[:id])
        @trainers.destroy
        redirect_to pokemon_trainers_path
    end

    private
        def pokemon_to_trainer(pokemon_id, trainer_id)
            @pokemon = CapturedPokemon.find(pokemon_id)
            @pokemon.update(:pokemon_trainer_id => trainer_id)
        end
        

    private
        def trainer_params
            params.require(:pokemon_trainer).permit(:name, :last_name, :region, :email)
        end
end

app/controllers/pokemons_controller.rb
class PokemonsController < ApplicationController
  before_action :set_pokemons, only: :index

  def index
    
  end

  def show
    @pokemons = CapturedPokemon.all
  end
  
  def new
    @pokemons = PokemonService.new
    create()
  end

  def create
    @pokemon = CapturedPokemon.create(get_pokemon)
    puts @pokemon.to_json    
    @pokemon.save
    redirect_to pokemons_path
  end  

  def update
    @pokemon = CapturedPokemon.find(params[:id])
    @pokemon.update()
    redirect_to pokemon_trainers_path
  end

  private
    def get_pokemon
      @pokemons = PokemonService.new().get_one(params[:url])
    end

  private
    def set_pokemons
      @pokemons = PokemonService.new().get_all
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/pokemon_trainers_helper.rb
module PokemonTrainersHelper
    def pokemons_for_select
        CapturedPokemon.all.pluck(:name, :id)
    end
end

app/views/layouts/application.html.haml
!!!
%html
  %head
    %meta{:content => "text/html; charset=UTF-8", "http-equiv" => "Content-Type"}/
    %title Pokemon Pasantes
    = csrf_meta_tags
    = csp_meta_tag
    = favicon_link_tag asset_path('favicon.ico')
    = stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload'
    = javascript_include_tag 'application', 'data-turbolinks-track': 'reload'
  %body
    = yield

app/views/pokemon_trainers/edit.html.haml
%div.content
  %div.form
    %h1= t('edit')
    = form_for @trainers do |f|
      %div.form-group
        = f.text_field :name, class: 'form-control', required: true, placeholder: t('name')
      %div.form-group
        = f.text_field :last_name, class: 'form-control', required: true, placeholder: t('last_name')
      %div.form-group
        = f.text_field :region, class: 'form-control', placeholder: t('region')
      %div.form-group
        = f.email_field :email, class: 'form-control', placeholder: t('email')
      %div.form-group
        = f.select(:captured_pokemon, pokemons_for_select, { include_blank: t('choose_pokemon') }, required: true, class: 'form-control')
      %div.form-group
        = f.submit :edit, class: 'btn btn-primary btn-lg btn-block', value: t('edit')

app/views/pokemon_trainers/index.html.haml
%div.m-5.p-5
  %h1= t('pokemon_trainers')
  %hr
  %div= link_to t('create'), new_pokemon_trainer_path , class: 'btn btn-success'
  %p
  %div.table-responsive-md
    %table.table.table-striped
      %thead.thead-dark
        %tr
          %th= t('name')
          %th= t('last_name')
          %th= t('region')
          %th= t('email')
          %th= t('edit')
          %th= t('delete')
      %tbody
        - @trainers.each do |trainer|
          %tr
            %td= trainer.name
            %td= trainer.last_name
            %td= trainer.region
            %td= trainer.email
            %td= link_to t('edit'), edit_pokemon_trainer_path(trainer), class: 'btn btn-primary'
            %td= link_to t('delete'), trainer, method: :delete, data: {confirm: t('delete_trainer')}, class: 'btn btn-danger'

app/views/pokemon_trainers/new.html.haml
%div.content
  %div.form
    %h1= t('create')
    = form_for @trainers do |f|
      %div.form-group
        = f.text_field :name, class: 'form-control', required: true, placeholder: t('name')
      %div.form-group
        = f.text_field :last_name, class: 'form-control', required: true, placeholder: t('last_name')
      %div.form-group
        = f.text_field :region, class: 'form-control', placeholder: t('region')
      %div.form-group
        = f.email_field :email, class: 'form-control', placeholder: t('email')
      %div.form-group
        = f.select(:captured_pokemon, pokemons_for_select, { include_blank: t('choose_pokemon') }, required: true, class: 'form-control')
      %div.form-group
        = f.submit :add, class: 'btn btn-success btn-lg btn-block', value: t('add')

app/views/pokemons/index.html.haml
%div.m-5
  %h1= t('list_pokemon')
  %div= link_to t('create'), pokemon_trainers_path , class: 'btn btn-success'
  %table.table.table-striped
    %thead
      %tr
        %th=t('name')
    %tbody
      - @pokemons.each do |pokemon|
        %tr
          %td= pokemon['name'].capitalize
          %td.d-flex.justify-content-end= link_to t('catch'), new_pokemon_path(pokemon), class: 'btn btn-danger'